<?php
########## Confixx(R) 3.2 Professional ############
####### Copyright SWsoft, Inc. 2004-2006 ##########
##### http://www.swsoft.com - info@swsoft.com #####

include_once( 'auth.php' );
include_once( '../include/class.SQLInteger.php' );
include_once( '../include/class.SQLString.php' );
include_once( '../include/module.DNSTemplate.php' );

global $DEBUG;
//$DEBUG = 1;

db_connect( $db_host, $db_user, $db_pass );

$timestamp = time();

$loRes      = new SQLString( $anbieter );
$loIP       = new SQLString( $stdip );
$loOldIP    = new SQLString( $old_stdip );
$loServerID = new SQLString( $ServerID );

if( ! isset( $ipadressen ) ){
	$ipadressen = array();
}

$lrId = safe_query2( "SELECT standardip FROM admin WHERE server_id=?", $loServerID );
list( $lcServerStdIP ) = db_fetch_array( $lrId );
db_free_query( $lrId );

/**
 * Cheks if admin tries to delete ip from reseller 
 * which already used by reseller's users.
 */
$laResIps = array();
$lrId = safe_query2( " SELECT ip, anbieter, kunde FROM ipadressen WHERE status=1 AND anbieter = ? ".
                     " AND server_id='$ServerID'", $loRes );

while( $laRow = db_fetch_array( $lrId ) ){
	$laResIps[] = $laRow['ip']; 
}

db_free_query( $lrId );

$laIpsDiff = array_diff( $laResIps, $ipadressen );
$lcTmpKey  = array_search( $old_stdip, $laIpsDiff );

if( $all == 1 && isset( $laIpsDiff[$lcTmpKey] ) ){
  unset( $laIpsDiff[$lcTmpKey] );
}

$laUsers = array();

foreach( $laIpsDiff as $lcIp  ){
  $lrId = safe_query2( " SELECT kunde FROM kunden WHERE anbieter =? AND ip = ? AND server_id = ?", 
                        $loRes, new SQLString( $lcIp ), $loServerID );
                      
  while( $laRow = db_fetch_array( $lrId ) ){
    $laUsers[$lcIp][] = $laRow['kunde'];
  }
  db_free_query( $lrId );
}

if( count( $laUsers ) ){
  $fehlertitel = ltext( 'anaeip2_errortitle' );
  $fehlertext  = '';

  foreach( $laUsers as $lcIp => $laUser ){
    $fehlertext  .= '<br>'.ltext( 'anaeip2_error3' , array( $lcIp, implode( ', ', $laUser ) ) );
  }
  include( 'anbieter_aendern_ips.php' );
  exit();
}


/**
* Set new standard IP for all of reseller's users using the standard IP.
*/
if( $all == 1 ){
	
   $id = safe_query2( "SELECT pns,sns FROM anbieter WHERE anbieter = ? ".
                      " AND server_id='$ServerID'", $loRes );
   list( $pns,$sns ) = db_fetch_array($id);
	 	
	 safe_query2( "UPDATE kunden SET ip = ?, httpd=1 ".
                " WHERE anbieter = ? AND ip = ? AND server_id='$ServerID'", 
                $loIP, $loRes, $loOldIP );
	 
	 $id = safe_query2( "SELECT * FROM ipadressen WHERE anbieter = ? ".
                      " AND server_id='$ServerID'", $loRes );
   
	 while ($werte = db_fetch_array( $id ) ){
		 $kunde = $werte["kunde"];
		 $ip = $werte["ip"];
		 $loKunde = new SQLString( $kunde );
     
		 safe_query2( "UPDATE kunden SET ip = ?, httpd=1  WHERE kunde = ? ".
                  " AND anbieter = ? AND server_id='$ServerID'", 
									new SQLString( $ip ), $loKunde, $loRes );
									
		$template = NULL;
    $id = db_query( "SELECT dns.domain, kunden.ip, dns.lastchange FROM dns, kunden ".
                    " WHERE kunden.server_id='$ServerID' AND dns.server_id='$ServerID' ".
                    " AND dns.kunde = kunden.kunde AND kunden.anbieter=?", $loRes );
                    
    while ( $werte = db_fetch_array( $id ) ){
			list( $zonefile, $seriennummer ) = ff_ProcessTemplate ( $anbieter, 
                                                              $domain = $werte["domain"], 
                                                              $werte["ip"],
				                                                      $werte["lastchange"], 
                                                              $template, 
                                                              $pns, 
                                                              $sns );
			db_query ( "UPDATE dns SET zonefile='$zonefile', lastchange='$seriennummer', neu='1' ".
                 " WHERE domain ='$domain' AND server_id='$ServerID'" );
    }
    
    db_query("update allgemein set dns='1' WHERE server_id='$ServerID'");
   }
   
 }

$loTime = new SQLInteger( $timestamp );

safe_query2( "UPDATE anbieter SET standardip = ? , lastchange = ? ".
             " WHERE anbieter = ? AND server_id='$ServerID'",
						 $loIP, $loTime, $loRes );

safe_query2( "UPDATE ipadressen SET anbieter = '', lastchange = ? ".
             " WHERE anbieter = ?  AND kunde = '' AND server_id='$ServerID'", 
						 $loTime, $loRes );

for ($i = 0; $i < count($ipadressen); $i++) {
	 $ip = $ipadressen[$i];
	 safe_query2( "UPDATE ipadressen SET anbieter = ? , lastchange = ? ".
                " WHERE ip = ?  and anbieter = '' AND server_id='$ServerID'", 
								$loRes, $loTime, new SQLString( $ip ) );
  }

if( $lcServerStdIP != $stdip ){
  safe_query2( "UPDATE ipadressen set anbieter = ? , lastchange = ? ".
               " WHERE ip = ?  AND anbieter = '' AND server_id='$ServerID'", 
  						 $loRes, $loTime, $loIP );
}

safe_query2( "UPDATE anbieter SET standardip = ? , lastchange = ? ".
             " WHERE anbieter = ?  AND server_id='$ServerID'", 
						 $loIP, $loTime, $loRes );

safe_query2( "UPDATE allgemein SET httpd = 1 WHERE server_id='$ServerID'" );

$fehlertitel = ltext("anaeip2_errortitle");
$fehlertext  = ltext("anaeip2_error1");
db_close();

if( $confixx_interface_version == 'powp' ){
	popPathBar( TRUE );
	include( "anbieter_start.php");
}else{
	include( "anbieter_aendern.php");
}

?>
