<?
include_once( 'class.CompoundValue.php' );
include_once( 'class.ValueLocale.php' );
include_once( 'class.ValueFromArray.php' );
include_once( 'class.ValueFormated.php' );
 
class LabelValue extends CompoundValue {

	function LabelValue( $pcLocaleKey, $pcValueKey, $pcFormatFunction = '', $paFromatArgs = array() ){
		parent::CompoundValue( new ValueLocale( $pcLocaleKey ) );
		if( $pcFormatFunction ){
			switch ($pcFormatFunction ) {
			case 'sinnv_intwert':
				if ( count($paFromatArgs) ) {
					$this->addValue( new ValueIntFormated( $pcValueKey, NULL, $pcFormatFunction, $paFromatArgs) );
				} else {
					$this->addValue( new ValueIntFormated( $pcValueKey, NULL ) );
				}
				break;
			case 'sinnv_kbwert':
				if ( count($paFromatArgs) ) {
					$this->addValue( new ValueKbFormated( $pcValueKey, NULL, $pcFormatFunction, $paFromatArgs) );
				} else {
					$this->addValue( new ValueKbFormated( $pcValueKey, NULL ) );
				}
			default:
				$this->addValue( new ValueFormated( $pcValueKey, NULL, $pcFormatFunction, $paFromatArgs) );
			}
		} else {
			$this->addValue( new ValueFromArray( $pcValueKey, NULL ) );
		}
	}

	function &getClone(){
		return new LabelValue( $this );
	}

}
?>