<?
/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once( dirname(__FILE__) . "/class.TRElement.php" );





class TableElement extends TagWithEndElement {

	/* -------------------- Constructor -------------------- */
	function TableElement( $pa_Attributes ) {
		$la_Arguments = func_get_args();
		array_unshift( $la_Arguments, "table" );
		call_user_func_array( array( &$this, "TagWithEndElement" ), $la_Arguments );
	}
	/* -------------------- end Constructor -------------------- */





	/* -------------------- rows (tr elements) -------------------- */
	function &AppendRow( $pa_Attributes = array() ) {
		$la_Arguments = func_get_args();
		array_shift( $la_Arguments );
		$lo_Row = new TRElement( $pa_Attributes );
		if( count( $la_Arguments ) )
			call_user_func_array( array( &$lo_Row, "AppendToContent" ), $la_Arguments );
		$this->AppendToContent( $lo_Row );
		return $this->GetContent(cc_LastElement);
	}

	function &InsertRow( $ps_Index, $pa_Attributes ) {
		$la_Arguments = func_get_args();
		array_splice( $la_Arguments, 0, 2 );
		$lo_Row = new TRElement( $pa_Attributes );
		if( count( $la_Arguments ) )
			call_user_func_array( array( &$lo_Row, "AppendToContent" ), $la_Arguments );
		$this->InsertToContent( $ps_Index, $lo_Row );
		return $this->GetContent($ps_Index);
	}
	/* -------------------- end rows (tr elements) -------------------- */

}
?>
