package Modules::Restore::Field;

########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

sub new {
  my $classname = shift;
  my %args = ( 
      'table'=>'',
      'field'=>'',
      'name'=>'',
      'link'=>undef,
      @_
 );	
  my $this = {
      'table'=>$args{'table'},
      'field'=>$args{'field'},
      'name' =>$args{'name'},
      'link'=>undef,
	     };

  bless ($this,$classname);
  my $name;
  if ($name = $args{'name'}){
    $this->Name($name);
  }
  return $this;
}

sub Name{
 my $this=shift;
 if (@_){
   my $name=shift;
   $this->{'name'}=$name;
   my ($table,$field)=split(/\./,$name);
   if ($field){
     $this->{'field'}=$field;
     $this->{'table'}=$table;
   }else{
     $this->{'field'}=$table;
   }
 }
 return $this->{'name'};
}

sub recalcName {
  my $this=shift;
  my ($name,$table,$field);
  if (@_){
    $name=shift;
    if(@_){
      $table=$name;
      $field=shift;
      $name="$table.$field";
      $this->{'name'}=$name;
      $this->{'table'}=$table;
      $this->{'field'}=$field;
      return $this->{'name'};
    }
  }
  if($name){
    $this->{'name'}=$name;
  }else{
    $name = $this->{'name'};
  }
  ($table,$field)=split(/\./,$name);
  if ($field){
    $this->{'field'}=$field;
    $this->{'table'}=$table;
  }else{
    $this->{'field'}=$table;
  }
  return $this->{'name'};
}
sub Table{
  my $this=shift;
  if (@_){
    $this->{'table'}=shift;
  } 
  $this->reclacName unless($this->{'table'});
  return $this->{'table'};
}

sub Field{
  my $this=shift;
  if (@_){
    $this->{'field'}=shift;
  }
  $this->reclacName unless($this->{'field'});
  return $this->{'field'};
}

sub Link{
  my $this=shift;
  if (@_){
    my $link=shift;
    if (ref($link)=~/Field/){
      $this->{'link'}=$link;
    }elsif(!defined($link)){
      $this->{'link'}=undef;
    }
  } 
  return $this->{'link'};
}

sub CopyFrom {
  my $this=shift;
  my $src=shift;
  return 0 unless (ref($src)=~/Field/);
  $this->Name($src->Name);
  $this->Link($src->Link);
  return 1;
}

return 1;
