<?
/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





/*
    AKA "abstract" class
*/
class Validator
{

    /* -------------------- Members -------------------- */
    var $ms_Required; // if TRUE - field value is required, so, it can not be empty
    var $ms_Empty; // what should be considered as empty value, usefull for <select>s
    /* -------------------- end Members -------------------- */





    /* -------------------- Constructor -------------------- */
    function Validator ( $ps_Required, $ps_Empty="" )
    {
	$this->SetRequired ($ps_Required);
	$this->SetEmpty ($ps_Empty);
    }
    /* -------------------- end Constructor -------------------- */





    /* -------------------- Get.../Set... -------------------- */
    function SetRequired ( $ps_Required )
    {
	$this->ms_Required = $ps_Required;
    }

    function GetRequired()
    {
	return $this->ms_Required;
    }

    function SetEmpty ( $ps_Empty )
    {
	$this->ms_Empty = $ps_Empty;
    }

    function GetEmpty()
    {
	return $this->ms_Empty;
    }
    /* -------------------- end Get.../Set... -------------------- */





    /* -------------------- "abstract" methods -------------------- */
    function Validate ( $ps_Value )
    {
	echo ( "method Validate should return TRUE for valid values and FALSE for invalid values" );
    }
    /* -------------------- end "abstract" methods -------------------- */

}
?>
