<?
/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once( dirname(__FILE__) . "/class.OneValueDataField.php" );
include_once( dirname(__FILE__) . "/../html/class.HTMLElement.php" );





class MLFDataField extends OneValueDataField {

	/* -------------------- Constructor -------------------- */
	function MLFDataField( $ps_Value="", $ps_Name=NULL ) {
		$this->OneValueDataField( $ps_Value, $ps_Name );
	}
	/* -------------------- end Constructor -------------------- */





	/* -------------------- definitions of "abstract" methods -------------------- */
	function GetInputPresentation() {
		return new HTMLElement( mlf_text($this->GetValue()) );
	}

	function GetOutputPresentation() {
		return new HTMLElement( mlf_text($this->GetValue()) );
	}

	function GetHiddenPresentation( $ps_ID=NULL ) {
		return new HTMLElement( "" );
	}
	/* -------------------- end definitions "abstract" methods -------------------- */

}
?>
